#ifndef MISCDELEGATE_H
#define MISCDELEGATE_H

#include "gmc-common_global.h"

#include <QTableView>
#include <QStyledItemDelegate>

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT MiscStyledItemDelegate : public QStyledItemDelegate
{

    Q_OBJECT

public:

    MiscStyledItemDelegate( QObject * /*parent*/ = nullptr );
    virtual ~MiscStyledItemDelegate();

    void updateEditorGeometry( QWidget * /*widget*/
                                     , const QStyleOptionViewItem & /*option*/
                                     , const QModelIndex & /*index*/ ) const override;

protected slots:

    void afterEditorChange();

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT ComboBoxDelegate : public MiscStyledItemDelegate
{

    Q_OBJECT

public:

    ComboBoxDelegate( QObject * /*parent*/ = nullptr );
    virtual ~ComboBoxDelegate();

    QWidget * createEditor( QWidget * /*parent*/
                                  , const QStyleOptionViewItem & /*option*/
                                  , const QModelIndex & /*index*/ ) const override;

    void setEditorData( QWidget * /*widget*/
                              , const QModelIndex & /*index*/ ) const override;

    void setModelData( QWidget * /*widget*/
                             , QAbstractItemModel * /*model*/
                             , const QModelIndex & /*index*/ ) const override;

    void paint( QPainter * /*painter*/
                      , const QStyleOptionViewItem & /*option*/
                      , const QModelIndex & /*index*/ ) const override;

protected:

    mutable bool _firstSetEditorData;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT SpinBoxDelegate : public MiscStyledItemDelegate
{

    Q_OBJECT

public:

    SpinBoxDelegate( QObject * /*parent*/ = nullptr );
    virtual ~SpinBoxDelegate();

    QWidget * createEditor( QWidget * /*parent*/
                                  , const QStyleOptionViewItem & /*option*/
                                  , const QModelIndex & /*index*/ ) const override;

    void setEditorData( QWidget * /*widget*/
                              , const QModelIndex & /*index*/ ) const override;

    void setModelData( QWidget * /*widget*/
                             , QAbstractItemModel * /*model*/
                             , const QModelIndex & /*index*/ ) const override;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT LineEditDelegate : public MiscStyledItemDelegate
{

    Q_OBJECT

public:

    LineEditDelegate( QObject * /*parent*/ = nullptr );
    virtual ~LineEditDelegate();

    QWidget * createEditor( QWidget * /*parent*/
                                  , const QStyleOptionViewItem & /*option*/
                                  , const QModelIndex & /*index*/ ) const override;

    void setEditorData( QWidget * /*widget*/
                              , const QModelIndex & /*index*/ ) const override;

    void setModelData( QWidget * /*widget*/
                             , QAbstractItemModel * /*model*/
                             , const QModelIndex & /*index*/ ) const override;

};

//******************************************************************************

class GMC_COMMON_SHARED_EXPORT MiscDelegateTableView : public QTableView
{

    Q_OBJECT

public:

    MiscDelegateTableView( QWidget * /*parent*/ );
    virtual ~MiscDelegateTableView();

protected:

    bool edit( const QModelIndex & /*index*/
                     , EditTrigger /*trigger*/
                     , QEvent * /*event*/ ) override;

};

//******************************************************************************

#endif
