#ifndef PGSQLMANAGER_H
#define PGSQLMANAGER_H

#include "gmc-common_global.h"

#include <QObject>
#include <QList>
#include <QFutureWatcher>
#include "appexception.h"


class PgsqlCluster;


class GMC_COMMON_SHARED_EXPORT PgsqlManager : public QObject
{
    Q_OBJECT

public:
    explicit PgsqlManager(QObject* const parent = nullptr);
    virtual ~PgsqlManager();

public:
    bool packagesInslled() const;
    void readClusters();
    const QList<PgsqlCluster*> getClusters() const;

private:
    QList<PgsqlCluster*> m_clusters;
};


class GMC_COMMON_SHARED_EXPORT PgsqlManagerAsync : public QObject
{
    Q_OBJECT

public:
    explicit PgsqlManagerAsync(QObject* parent = nullptr);
    virtual ~PgsqlManagerAsync();

signals:
    void clustersReaded(const QList<PgsqlCluster*>& clusters);
    void exceptionArise(const AppException& exception);

public:
    void startReadClusters();

private slots:
    void readClustersFinished();

private:
    void performReadClusters();

private:
    QFutureWatcher<void> m_watcher;
    PgsqlManager m_manager;
};


#endif // PGSQLMANAGER_H
