#ifndef PREVIEWDIALOG_H
#define PREVIEWDIALOG_H

#include "gmc-common_global.h"

#include <QDialog>

class QPrinter;

namespace Ui
{
class PreviewDialog;
}

class GMC_COMMON_SHARED_EXPORT PreviewDialog : public QDialog
{

    Q_OBJECT

public:

    static PreviewDialog* instance( QWidget * /*parent*/ = nullptr);
    virtual ~PreviewDialog();

    void preview( const QString & /*text*/ );

protected:

    PreviewDialog( QWidget * /*parent*/ = nullptr );

    void loadSettings();
    void saveSettings() const;

protected slots:

    void print();
    void exportHtml();
    void clear();

private:

    static PreviewDialog *_instance;

    Ui::PreviewDialog *_ui;
    QPrinter *_printer = nullptr;
    QString _htmlText;

};

#endif // PREVIEWDIALOG_H
