#ifndef RECORDWIDGET_H
#define RECORDWIDGET_H

#include "gmc-common_global.h"

#include <QWidget>

class QAbstractItemDelegate;

class RecordModel;

namespace Ui
{
class RecordWidget;
}

class GMC_COMMON_SHARED_EXPORT RecordWidget : public QWidget
{
    Q_OBJECT

signals:

    void dataChanged();
    void importData();

public:

    RecordWidget(QWidget *parent = nullptr);
    virtual ~RecordWidget();

    RecordModel *recordModel();
    void setRecordModel( RecordModel *recordModel ); //delete _recordModel; _recordModel = recordModel; _recordModel->setParent( this );
    void setItemDelegateForColumn( int  /*column*/
                                 , QAbstractItemDelegate * /*delegate*/ );

    bool isEditEnabled() const;
    void setEditEnabled( bool editEnabled );

    const QString &settingsKey() const;
    void setSettingsKey(const QString &settingsKey);

    void showCopyButton(bool visible);
    void setCopyFormat(const QStringList &format);

protected:

    void loadSettings();
    void saveSettings();

    void disconnectModels();
    void connectModels();

protected slots:

    void insertRow();
    void removeRow();
    void clearRows();
    void enableButtons();
    void copyRequest();

protected:

    Ui::RecordWidget *_ui;

    bool _editEnabled;
    RecordModel *_recordModel;
    QString _settingsKey;

private:
    bool m_copyButtonVisible = false;
    QStringList m_copyFormat;
};

#endif // RECORDWIDGET_H
