#ifndef TASKOBSERVERMODEL_H
#define TASKOBSERVERMODEL_H

#include "gmc-common_global.h"

#include <QSortFilterProxyModel>

class TaskObserver;

class GMC_COMMON_SHARED_EXPORT TaskObserverModel : public QAbstractListModel
{

    Q_OBJECT

public:

    enum ColumnType { DescriptionColumn
                    , StatusColumn
                    , MessageColumn
                    , _CountColumn };

    TaskObserverModel( TaskObserver * /*taskObserver*/, QObject * /*parent*/ = nullptr);
    virtual ~TaskObserverModel();
    int columnCount( const QModelIndex & /*parent*/ ) const override;
    QVariant data( const QModelIndex & /*index*/
                         , int /*role*/ = Qt::DisplayRole) const override;
    bool setData( const QModelIndex & /*index*/
                        , const QVariant & /*value*/
                        , int /*role*/ = Qt::EditRole ) override;
    QVariant headerData( int /*section*/
                               , Qt::Orientation /*orientation*/
                               , int /*role*/ ) const override;
    int rowCount( const QModelIndex & /*parent*/ ) const override;

protected slots:

    void tasksAboutToBeInserted( int /*start*/, int /*end*/ );
    void tasksAboutToBeRemoved( int /*start*/, int /*end*/ );
    void tasksInserted( int /*start*/, int /*end*/ );
    void tasksRemoved( int /*start*/, int /*end*/ );
    void taskDataChanged( int /*row*/ );

protected:

    TaskObserver *_taskObserver;

};

//******************************************************************************

#endif // TASKOBSERVERMODEL_H
