#ifndef THREAD_H
#define THREAD_H

#include "gmc-common_global.h"

#include <QThread>
#include <QAtomicInt>
#include <QMutex>
#include <QSemaphore>

class AbstractTask;

#define THREAD_BUFF_SIZE 0x40

class GMC_COMMON_SHARED_EXPORT Thread : public QThread
{

    Q_OBJECT

    friend class AbstractTask;

public:

    static bool put( AbstractTask * /*task*/ );

    Thread( QObject * /*parent*/ = nullptr );
    virtual ~Thread();

protected:

    void run() override;

private:

    static volatile bool _stopThread;
    static QAtomicInt _threadsCount;

    static AbstractTask *_buffer[ THREAD_BUFF_SIZE ];
    static QSemaphore _emptyBuffer;
    static QSemaphore _fullBuffer;

    static int _rearBound;
    static int _frontBound;
    static QMutex _frontBoundMutex;

    int _number;
};

#endif // THREAD_H
